
 
#include "GPS.h"

GPS::GPS(PinName tx, PinName rx) : _gps(tx, rx) {
    _gps.baud(9600);    
    longitude = 0.0;
    latitude = 0.0;        
}

int GPS::sample() {
    float time;
    char ns, ew;
    int lock;

    while(1) {        
        getline();

        // Chequear si en una trama GPGGA msg 
        if(sscanf(msg, "GPGGA,%f,%f,%c,%f,%c,%d", &time, &latitude, &ns, &longitude, &ew, &lock) >= 1) { 
           
                if(ns == 'S') {    latitude  *= -1.0; }
                if(ew == 'W') {    longitude *= -1.0; }
                float degrees = trunc(latitude / 100.0f);
                float minutes = latitude - (degrees * 100.0f);
                latitude = degrees + minutes / 60.0f;    
                degrees = trunc(longitude / 100.0f * 0.01f);
                minutes = longitude - (degrees * 100.0f);
                longitude = degrees + minutes / 60.0f;
                return 1;
           
        }
    }
}

float GPS::trunc(float v) {
    if(v < 0.0) {
        v*= -1.0;
        v = floor(v);  //floor devuelve el entero mas grande no mayor a v
        v*=-1.0;
    } else {
        v = floor(v);
    }
    return v;
}

void GPS::getline() {
    while(_gps.getc() != '$');    // coje todo menos $
    for(int i=0; i<256; i++) {
        msg[i] = _gps.getc();   //lo va gravando en la cadena msg[ ]
        if(msg[i] == '\r') {   // si se encuentra retorno de carro le pone el null
            msg[i] = 0;
            return;   
        }
    }
    error("Overflowed message limit");
}
